require 'pg'

require 'common/davical_plugin'
require 'rm/rm_plugin'

class DavicalMv
  #
  # DAViCal only supports Postgres, so even if we ever are
  # database-agnostic, this plugin can't be.
  #
  include DavicalPlugin
  include MvPlugin


  def mv_domain(from, to)
    # DAViCal doesn't have a concept of domains.
  end


  def mv_user(from, to)
    # Delete the given username. DAViCal uses foreign keys properly
    # and only supports postgres, so we let the ON UPDATE CASCADE
    # trigger handle most of the work.
    sql_queries = ['UPDATE usr SET username = $1 WHERE username = $2']

    begin
      connection = PGconn.connect(@db_host,
                                  @db_port,
                                  @db_opts,
                                  @db_tty,
                                  @db_name,
                                  @db_user,
                                  @db_pass)

      sql_queries.each do |sql_query|
        connection.query(sql_query, [to, from])
      end

      connection.close()

    rescue PGError => e
      # Pretend like we're database-agnostic in case we ever are.
      raise DatabaseError.new(e)
    end

  end

end
